/* Re-modified by Sang Lim                    */
/* CPS 615 Assignment #2                      */

/*--------------------------------------------*/
/* Written by William Gropp, ANL              */
/* Modified by Saleh Elmohamed, NPAC          */
/*--------------------------------------------*/
#include <stdio.h>
#include <mpi.h>
#include <math.h>

int main(int argc, char *argv[])
{
  
  int done=0, n = 0, myid, numprocs, i,j, rc,root = 0;
  double PI25DT = 3.14159265358979323842643;
  
/* 
   rbuf will be used by root for collect sum of each process calculation
   I make it 8 elements of array because there is at most 8 processors.
*/
  double mypi, pi, h, sum, x, a,rbuf[8];
  
  MPI_Init(&argc, &argv);
  
  MPI_Comm_size(MPI_COMM_WORLD, &numprocs);
  
  MPI_Comm_rank(MPI_COMM_WORLD, &myid);
 
  n = 1000000;
  MPI_Bcast(&n, 1, MPI_INT, 0, MPI_COMM_WORLD);
  h = 1.0 /(double) n;
  sum = 0.0;
  
  for (i=myid+1; i<=n; i+=numprocs){
     x = h *((double)i - 0.5);
     sum += 4.0/(1.0 + x*x);
  }
  mypi = h * sum;
/*
   Using Gather function collect each processors calculation into root
   processor which is processor 0.
*/
  MPI_Gather(&mypi,1,MPI_DOUBLE,rbuf,1,MPI_DOUBLE,root,MPI_COMM_WORLD);

/*
   In root processer, calculate PI using collected data from each 
   processors (for loop). and print out result.
*/
  if (myid == root){
     for (i = 0; i <= numprocs ; i++)
        pi += rbuf[i];
     printf("Interval of %d\n",n);
     printf("pi is approximately %.16f, and the Error is %.16f\n", 
             pi, fabs(pi - PI25DT));
  }
/*
    Send result to each processor using Bcast and print out processor ID 
    and receive data.
*/
  MPI_Bcast(&pi,1,MPI_DOUBLE,root,MPI_COMM_WORLD);
  printf("Processor ID : %d and PI : %.16f\n",myid,pi);
  
  MPI_Finalize;
}


  
     
